﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
'Custom View class
#Event: TextChanged
#DesignerProperty: Key: Date, DisplayName: Display date, FieldType: Boolean, DefaultValue: True, Description: View date.
#DesignerProperty: Key: Time, DisplayName: Display time, FieldType: Boolean, DefaultValue: True, Description: View time.
Sub Class_Globals
	Private fx As JFX
	Private xui As XUI
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private mProps As Map
	Private mPane As Pane
	Private wincal As Form
	Private winhour As Form
			
	Private TG,TM,TA,HH,MM As TextField
	Private L0,L1,L2,L3,L4,L5,L6 As Label
	Private chm,cha As ChoiceBox
	
	Private newdate,caldate As Long
	Private openc,openo As Boolean
	Private giorni() As String = Array As String ("Do","Lu","Ma","Me","Gi","Ve","Sa")
	Private mesi() As String = Array As String ("Gennaio","Febbraio","Marzo","Aprile","Maggio","Giugno","Luglio","Agosto","Settembre","Ottobre","Novembre","Dicembre")
	Private anni As List
	Private oldcol As String
	Private sx,sy As Int
	Private temp,robot As JavaObject
	Private t As Timer
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	DateTime.DateFormat = "dd/MM/yyyy"
	DateTime.TimeFormat = "HH:mm:ss"
	
	TG = CreateFields("TG")
	TG.Tag = "G"
	If TG.Text = "" Then
		TG.Text = NumberFormat2(DateTime.GetDayOfMonth(DateTime.Now),2,0,0,False)
	End If
	TM = CreateFields("TM")
	TM.Tag = "ME"
	If TM.Text = "" Then
		TM.Text = NumberFormat2(DateTime.GetMonth(DateTime.Now),2,0,0,False)
	End If
	TA = CreateFields("TA")
	TA.Tag = "A"
	If TA.Text = "" Then
		TA.Text = NumberFormat2(DateTime.GetYear(DateTime.Now),4,0,0,False)
	End If
	HH = CreateFields("HH")
	HH.Tag = "H"
	If HH.Text = "" Then
		HH.Text = NumberFormat2(DateTime.GetHour(DateTime.Now),2,0,0,False)
	End If
	MM = CreateFields("MM")
	MM.Tag = "MI"
	If MM.Text = "" Then
		MM.Text = NumberFormat2(DateTime.GetMinute(DateTime.Now),2,0,0,False)
	End If
	
	If newdate = 0 Then
		newdate = DateTime.Now
	End If
	
	L0 = CreateLabel("LD","FontAwesome",13,True,0,"LIGHTGRAY")
	L1 = CreateLabel("LA","FontAwesome",13,True,0,"BLACK")
	L2 = CreateLabel("LA","FontAwesome",13,True,0,"BLACK")
	L3 = CreateLabel("LO","FontAwesome",13,True,0,"LIGHTGRAY")
	L4 = CreateLabel("LA","FontAwesome",13,True,0,"BLACK")
	L5 = CreateLabel("LA","",48,True,1,"BLACK")
	L6 = CreateLabel("LA","",48,True,1,"BLACK")
	
	chm.Initialize("CHM")
	chm.Items.AddAll(mesi)
	chm.Style = "-fx-background-color:#D3D3D3,#FFFFFF;-fx-background-insets: 0, 1;-fx-background-radius: 0, 0;"
	anni.Initialize
	For i = 1970 To 2100
		anni.add(i)
	Next
	cha.Initialize("CHA")
	cha.Items.AddAll(anni)
	cha.Style = "-fx-background-color:#D3D3D3,#FFFFFF;-fx-background-insets: 0, 1;-fx-background-radius: 0, 0;"
	
	InitializeWins
	
	t.Initialize("TIM",300)
	t.Enabled = True
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	mProps = Props
	If Base.PrefWidth > 245 Then
		Base.PrefHeight = 50
	End If
End Sub

#Region GET
Public Sub GetBase As Pane
	Return mBase
End Sub

Public Sub GetData As Long
	Return newdate
End Sub

Public Sub GetTime As Long
	Return newdate
End Sub
#End Region
#Region SET
Public Sub SetDateTime(date As Long)
	TG.Text = NumberFormat2(DateTime.GetDayOfMonth(date),2,0,0,False)
	TM.Text = NumberFormat2(DateTime.GetMonth(date),2,0,0,False)
	TA.Text = NumberFormat2(DateTime.GetYear(date),4,0,0,False)
	HH.Text = NumberFormat2(DateTime.GetHour(date),2,0,0,False)
	MM.Text = NumberFormat2(DateTime.GetMinute(date),2,0,0,False)
	DateControl
End Sub
#End Region
#Region ROUTINES
Private Sub CreateFields(event As String) As TextField
	Dim tf As TextField
	tf.Initialize(event)
	CSSUtils.SetBackgroundColor(tf,fx.Colors.Transparent)
	CSSUtils.SetBorder(tf,0,fx.Colors.gray,0)
	CSSUtils.SetStyleProperty(tf,"-fx-font-size","13")
	CSSUtils.SetStyleProperty(tf,"-fx-alignment","CENTER")
	Return tf
End Sub

Private Sub CreateLabel(event As String,font As String,size As Int,bold As Boolean,border As Int,color As String) As Label
	Dim la As Label
	la.initialize(event)
	CSSUtils.SetStyleProperty(la,"-fx-text-fill",color)
	If font <> "" Then
		CSSUtils.SetStyleProperty(la,"-fx-font-family",font)
	End If
	CSSUtils.SetStyleProperty(la,"-fx-font-size",size)
	CSSUtils.SetBorder(la,border,fx.Colors.LightGray,0)
	CSSUtils.SetStyleProperty(la,"-fx-alignment","CENTER")
	If bold Then
		CSSUtils.SetStyleProperty(la,"-fx-font-weight","bold")
	End If
	Return la
End Sub

Public Sub DateControl As Boolean
	Dim success As Boolean = True
	Dim ctrdata As String = TG.Text&"/"&TM.Text&"/"&TA.Text
	Try
		newdate = DateTime.DateParse(ctrdata)
		success = True
	Catch
		success = False
	End Try
	Return success
End Sub
#End Region
#Region Drawing

Private Sub InitializeWins
	wincal.Initialize("CAL",198,200)
	wincal.Resizable = False
	wincal.SetFormStyle("UNDECORATED")
	wincal.BackColor = fx.Colors.Transparent

	winhour.Initialize("HOUR",198,86)
	winhour.Resizable = False
	winhour.SetFormStyle("UNDECORATED")
	winhour.BackColor = fx.Colors.Transparent
End Sub

Private Sub DrawView(base As Pane)
	Dim xd,yd As Int
	
	base.RemoveAllNodes
	CSSUtils.SetBackgroundColor(base,fx.Colors.White)
	
	xd = 4
	yd = 3
	If base.PrefWidth > 245 Then
		If 	mProps.Get("Date") Then
			L0.Text = Chr(0xF073)
			base.AddNode(L0,xd,yd,20,base.PrefHeight-6)
			xd = xd + 20
			yd = yd - 4
			base.AddNode(TG,xd,yd,36,base.PrefHeight-6)
			xd = xd + 35
			yd = yd + 4
			L1.Text = "/"
			base.AddNode(L1,xd,yd,8,base.PrefHeight-6)
			xd = xd + 7
			yd = yd - 4
			base.AddNode(TM,xd,yd,36,base.PrefHeight-6)
			xd = xd + 35
			yd = yd + 4
			L2.Text = "/"
			base.AddNode(L2,xd,yd,8,base.PrefHeight-6)
			xd = xd + 7
			yd = yd - 4
			base.AddNode(TA,xd,yd,48,base.PrefHeight-6)
		End If
		If mProps.Get("Time") Then
			L3.Text = Chr(0xF017)
			xd = xd + 56
			If 	mProps.Get("Date") Then
				yd = yd + 4
			End If
			base.AddNode(L3,xd,yd,16,base.PrefHeight-6)
			xd = xd + 13
			yd = yd - 4
			base.AddNode(HH,xd,-1,36,base.PrefHeight-6)
			xd = xd + 27
			yd = yd + 4
			L4.Text = ":"
			base.AddNode(L4,xd,3,8,base.PrefHeight-6)
			xd = xd - 1
			yd = yd - 4
			base.AddNode(MM,xd,yd,36,base.PrefHeight-6)
		End If
	Else
		If 	mProps.Get("Date") Then
			L0.Text = Chr(0xF073)
			base.AddNode(L0,xd,yd,20,24)
			xd = xd + 20
			yd = yd - 4
			base.AddNode(TG	,xd,yd,36,20)
			xd = xd + 35
			yd = yd + 4
			L1.Text = "/"
			base.AddNode(L1,xd,yd,8,24)
			xd = xd + 7
			yd = yd - 4
			base.AddNode(TM,xd,yd,36,20)
			xd = xd + 35
			yd = yd + 4
			L2.Text = "/"
			base.AddNode(L2,xd,yd,8,24)
			xd = xd + 7
			yd = yd - 4
			base.AddNode(TA,xd,yd,48,20)
		End If
		If mProps.Get("Time") Then
			xd = 4
			If mProps.Get("Date") Then
				yd = 24
			Else
				yd = 3
			End If
			L3.Text = Chr(0xF017)
			base.AddNode(L3,xd,yd,20,24)
			xd = xd + 19
			yd = yd - 2
			base.AddNode(HH,xd,yd,36,20)
			xd = xd + 35
			yd = yd + 2
			L4.Text = ":"
			base.AddNode(L4,xd,yd,8,24)
			xd = xd + 7
			yd = yd - 2
			base.AddNode(MM,xd,yd,36,20)
		End If
	End If
	Sleep(0)
End Sub

Sub DrawCalendar
	mPane = wincal.RootPane
	mPane.Tag = "CAL"
	Dim body As Pane
	body.Initialize("EBO")
	body.SetSize(198,200)
	CSSUtils.SetBackgroundColor(body,fx.Colors.White)
	CSSUtils.SetBorder(body,1,fx.Colors.LightGray,0)
	'disegno il calendario
	'comando pre
	Dim lp As Label
	lp.Initialize("LC")
	lp.Font = fx.CreateFontAwesome(16)
	lp.Text = Chr(0xF104)
	lp.Tag = "PRE"
	lp.Alignment = "TOP_CENTER"
	body.AddNode(lp,2,4,22,20)
	' mese
	'If chm.SelectedIndex < 0 Then
	chm.SelectedIndex = DateTime.GetMonth(newdate)-1
	'End If
	body.AddNode(chm,27,2,88,24)
	' anni
	'If cha.SelectedIndex < 0 Then
	cha.SelectedIndex = anni.IndexOf(DateTime.Getyear(newdate))
	'End If
	body.AddNode(cha,117,2,54,24)
	' comando prox
	Dim lp As Label
	lp.Initialize("LC")
	lp.Font = fx.CreateFontAwesome(16)
	lp.Text = Chr(0xF105)
	lp.Tag = "PRO"
	lp.Alignment = "TOP_CENTER"
	body.AddNode(lp,body.PrefWidth-24,4,22,20)
	' Testate giorni
	Dim x,y,passo As Int
	For i = 0 To 6
		Dim lp As Label
		lp.Initialize("GT")
		lp.Text = giorni(i)
		lp.Tag = "GT"
		lp.Alignment = "TOP_CENTER"
		lp.Style = "-fx-font-weight: bold;"
		If passo >= 7 Then
			x = 2
			passo = 0
		Else
			x = 2 + (28 * passo)
		End If
		passo = passo + 1
		body.AddNode(lp,x,26,26,20)
	Next
	' Giorni
	DateTime.DateFormat = "dd/MM/yyyy"
	Dim dt As String = DateTime.Date(newdate)
	dt = "01"&dt.SubString(2)
	caldate = DateTime.DateParse(dt)
	Dim lun As Int = DateTime.GetDayOfWeek(caldate)-1
	If lun > 1 Then
		caldate = caldate - (86400000 * lun)
	End If
	For i = 1 To 42
		Dim lp As Label
		lp.Initialize("LG")
		lp.Text = NumberFormat2(DateTime.GetDayOfMonth(caldate),2,0,0,False)
		If DateTime.GetDayOfMonth(newdate) = DateTime.GetDayOfMonth(caldate) And DateTime.GetMonth(newdate) = DateTime.GetMonth(caldate) Then
			CSSUtils.SetBackgroundColor(lp,fx.Colors.ARGB(50,0,0,255))
		else if DateTime.GetMonth(newdate) = DateTime.GetMonth(caldate) Then
			CSSUtils.SetBackgroundColor(lp,fx.Colors.ARGB(50,0,255,0))
		End If
		lp.Tag = DateTime.GetMonth(caldate)
		caldate = DateTime.Add(caldate,0,0,1)
		lp.Alignment = "CENTER"
		If passo >= 7 Then
			x = 2
			passo = 0
			CSSUtils.SetBorder(lp,2,fx.colors.ARGB(100,255,0,0),0)
		Else
			x = 2 + (28 * passo)
			CSSUtils.SetBorder(lp,2,fx.colors.LightGray,0)
		End If
		passo = passo + 1
		
		body.AddNode(lp,x,44+(26*y),26,24)
		y = i/7
	Next
	mPane.AddNode(body,0,0,body.PrefWidth,body.PrefHeight)
	'win.rootpane.AddNode(mPane,mBase.Left-7,(mBase.Top+mBase.Height)+1,170,mBase.PrefHeight)
	openc = True
	Sleep(0)
End Sub

Sub DrawClock
	mPane = winhour.RootPane
	mPane.Tag = "CLO"
	'mPane.SetSize(198,100)
	'CSSUtils.SetBackgroundColor(mPane,fx.colors.transparent)
	'mPane.Style = "-fx-background-color: white;-fx-background-radius: 0;-fx-background-insets: 0 7 7 7;-fx-effect: dropshadow(gaussian, lightgrey, 10, 0, 0, 0);"
	Dim body As Pane
	body.Initialize("EBO")
	body.SetSize(198,86)
	CSSUtils.SetBackgroundColor(body,fx.Colors.White)
	CSSUtils.SetBorder(body,1,fx.Colors.LightGray,0)
	L5.Text = HH.Text
	body.AddNode(L5,4,4,94,78)
	L6.Text = MM.Text
	body.AddNode(L6,100,4,94,78)
	Dim lo1 As Label = CreateLabel("LO1","FontAwesome",26,True,0,"BLACK")
	lo1.Text = Chr(0xF0D9)
	body.AddNode(lo1,4,30,20,20)
	Dim lo2 As Label = CreateLabel("LO2","FontAwesome",26,True,0,"BLACK")
	lo2.Text = Chr(0xF0DA)
	body.AddNode(lo2,80,30,20,20)
	Dim lm1 As Label = CreateLabel("LM1","FontAwesome",26,True,0,"BLACK")
	lm1.Text = Chr(0xF0D9)
	body.AddNode(lm1,100,30,20,20)
	Dim lm2 As Label = CreateLabel("LM2","FontAwesome",26,True,0,"BLACK")
	lm2.Text = Chr(0xF0DA)
	body.AddNode(lm2,176,30,20,20)
	mPane.AddNode(body,0,0,body.PrefWidth,body.PrefHeight)
	'rootpane.AddNode(mPane,mBase.Left-7,(mBase.Top+mBase.Height)+1,170,mBase.PrefHeight)
	openo = True
	Sleep(0)
End Sub



#End Region
#Region Events

Sub TIM_Tick
	robot = temp.InitializeStatic("com.sun.glass.ui.Application").RunMethodJO("GetApplication",Null).RunMethodJO("createRobot",Null)
	sx = robot.RunMethod("getMouseX",Null)
	sy = robot.RunMethod("getMouseY",Null)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	DrawView(mBase)
End Sub

Sub TG_TextChanged (Old As String, New As String)
	Dim tf As TextField = Sender
	Dim update As Boolean
	Try
		Dim text As String = Regex.Replace("\D",New,"")
		If New <> text Then
			update = True
		End If
	Catch
		Log(LastException.Message)
	End Try
	If text.Length > 2 Then   ' 2 is the max length allowed you can change this :)
		update = False
	End If
	If update Then
		tf.Text = text
		tf.SetSelection(text.Length,text.Length)
	End If
	CSSUtils.SetBorder(mBase,1,fx.Colors.LightGray,0)
	If SubExists(mCallBack,mEventName&"_TextChanged") Then
		DateControl
		CallSub(mCallBack,mEventName & "_TextChanged")
	End If
End Sub

Sub TM_TextChanged (Old As String, New As String)
	Dim tf As TextField = Sender
	Dim update As Boolean
	Try
		Dim text As String = Regex.Replace("\D",New,"")
		If New <> text Then
			update = True
		End If
	Catch
		Log(LastException.Message)
	End Try
	If text.Length > 2 Then   ' 2 is the max length allowed you can change this :)
		update = False
	End If
	If update Then
		tf.Text = text
		tf.SetSelection(text.Length,text.Length)
	End If
	CSSUtils.SetBorder(mBase,1,fx.Colors.LightGray,0)
	If SubExists(mCallBack,mEventName&"_TextChanged") Then
		DateControl
		CallSub(mCallBack,mEventName & "_TextChanged")
	End If
End Sub

Sub TA_TextChanged (Old As String, New As String)
	Dim tf As TextField = Sender
	Dim update As Boolean
	Try
		Dim text As String = Regex.Replace("\D",New,"")
		If New <> text Then
			update = True
		End If
	Catch
		Log(LastException.Message)
	End Try
	If text.Length > 4 Then   ' 2 is the max length allowed you can change this :)
		update = False
	End If
	If update Then
		tf.Text = text
		tf.SetSelection(text.Length,text.Length)
	End If
	CSSUtils.SetBorder(mBase,1,fx.Colors.LightGray,0)
	If SubExists(mCallBack,mEventName&"_TextChanged") Then
		DateControl
		CallSub(mCallBack,mEventName & "_TextChanged")
	End If
End Sub

Sub HH_TextChanged (Old As String, New As String)
	Dim tf As TextField = Sender
	Dim update As Boolean
	Try
		Dim text As String = Regex.Replace("\D",New,"")
		If New <> text Then
			update = True
		End If
	Catch
		Log(LastException.Message)
	End Try
	If text.Length >= 4 Then   ' 4 is the max length allowed you can change this :)
		text = NumberFormat2(text,4,0,0,False)
		update = True
	End If
	If update Then
		tf.Text = text
		tf.SetSelection(text.Length,text.Length)
	End If
	CSSUtils.SetBorder(mBase,1,fx.Colors.LightGray,0)
	If SubExists(mCallBack,mEventName&"_TextChanged") Then
		DateControl
		CallSub(mCallBack,mEventName & "_TextChanged")
	End If
End Sub

Sub MM_TextChanged (Old As String, New As String)
	Dim tf As TextField = Sender
	Dim update As Boolean
	Try
		Dim text As String = Regex.Replace("\D",New,"")
		If New <> text Then
			update = True
		End If
	Catch
		Log(LastException.Message)
	End Try
	If text.Length >= 4 Then   ' 4 is the max length allowed you can change this :)
		text = NumberFormat2(text,4,0,0,False)
		update = True
	End If
	If update Then
		tf.Text = text
		tf.SetSelection(text.Length,text.Length)
	End If
	CSSUtils.SetBorder(mBase,1,fx.Colors.LightGray,0)
	If SubExists(mCallBack,mEventName&"_TextChanged") Then
		DateControl
		CallSub(mCallBack,mEventName & "_TextChanged")
	End If
End Sub

Sub TG_FocusChanged (HasFocus As Boolean)
	Dim tf As TextField = Sender
	If tf.IsInitialized = False Then Return
	If HasFocus Then
		If DateControl Then
			tf.Text = NumberFormat2(tf.Text,2,0,0,False)
		Else
			CSSUtils.SetBorder(mBase,1,fx.Colors.Red,0)
		End If
	Else
		If tf.Text = "" Then Return
		tf.Text = NumberFormat2(tf.Text,2,0,0,False)
	End If
End Sub

Sub TM_FocusChanged (HasFocus As Boolean)
	Dim tf As TextField = Sender
	If tf.IsInitialized = False Then Return
	If HasFocus Then
		If DateControl Then
			tf.Text = NumberFormat2(tf.Text,2,0,0,False)
		Else
			CSSUtils.SetBorder(mBase,1,fx.Colors.Red,0)
		End If
	Else
		If tf.Text = "" Then Return
		tf.Text = NumberFormat2(tf.Text,2,0,0,False)
	End If	
End Sub

Sub TA_FocusChanged (HasFocus As Boolean)
	Dim tf As TextField = Sender
	If tf.IsInitialized = False Then Return
	If HasFocus Then
		If DateControl Then
			tf.Text = NumberFormat2(tf.text,4,0,0,False)
		Else
			CSSUtils.SetBorder(mBase,1,fx.Colors.Red,0)
		End If
	Else
		If tf.Text = "" Then Return
		tf.Text = NumberFormat2(tf.text,4,0,0,False)
	End If
End Sub

Sub LD_MouseEntered (EventData As MouseEvent)
	Dim lp As Label = Sender
	CSSUtils.SetStyleProperty(lp,"-fx-text-fill","#000000")
End Sub

Sub LD_MouseExited (EventData As MouseEvent)
	Dim lp As Label = Sender
	CSSUtils.SetStyleProperty(lp,"-fx-text-fill","#D3D3D3")
End Sub

Sub LD_MouseClicked (EventData As MouseEvent)
	Dim lp As Label = Sender
	CSSUtils.SetStyleProperty(lp,"-fx-text-fill","#000000")
	If openo Then
		openo = True
		winhour.Close
	End If
	If openc Then Return
	InitializeWins
	DrawCalendar
	wincal.WindowTop = sy
	wincal.WindowLeft = sx
	wincal.AlwaysOnTop = True
	wincal.Show
End Sub

Sub CAL_FocusChanged (HasFocus As Boolean)
	If HasFocus = False Then
		openc = False
		wincal.Close
	End If
End Sub

Sub LO_MouseEntered (EventData As MouseEvent)
	Dim lp As Label = Sender
	CSSUtils.SetStyleProperty(lp,"-fx-text-fill","#000000")
End Sub

Sub LO_MouseExited (EventData As MouseEvent)
	Dim lp As Label = Sender
	CSSUtils.SetStyleProperty(lp,"-fx-text-fill","#D3D3D3")
End Sub

Sub LO_MouseClicked (EventData As MouseEvent)
	Dim lp As Label = Sender
	CSSUtils.SetStyleProperty(lp,"-fx-text-fill","#000000")
	If openc Then
		openc = False
		wincal.Close
	End If
	If openo Then Return
	InitializeWins
	DrawClock
	winhour.WindowTop = sy
	winhour.WindowLeft = sx
	winhour.AlwaysOnTop = True
	winhour.Show
End Sub

Sub HOUR_FocusChanged (HasFocus As Boolean)
	If HasFocus = False Then
		openo = False
		winhour.Close
	End If
End Sub

Sub LC_MouseEntered (EventData As MouseEvent)
	Dim lp As Label = Sender
	CSSUtils.SetBackgroundColor(lp,fx.Colors.LightGray)
End Sub

Sub LC_MouseExited (EventData As MouseEvent)
	Dim lp As Label = Sender
	Try
		CSSUtils.SetBackgroundColor(lp,fx.Colors.Transparent)
	Catch
		Log(LastException.Message)
	End Try
End Sub

Sub LC_MouseClicked (EventData As MouseEvent)
	EventData.Consume
	Dim ll As Label = Sender
	If ll.Tag = "PRE" Then
		If chm.SelectedIndex > 0 Then
			chm.SelectedIndex = chm.SelectedIndex - 1
		End If
	Else
		If chm.SelectedIndex < 11 Then
			chm.SelectedIndex = chm.SelectedIndex + 1
		End If
	End If
End Sub

Sub LG_MouseEntered (EventData As MouseEvent)
	Dim lp As Label = Sender
	oldcol = CSSUtils.GetStyleProperty(lp,"-fx-border-color")
	CSSUtils.SetBorder(lp,2,fx.Colors.Blue,0)
End Sub

Sub LG_MouseExited (EventData As MouseEvent)
	Try
		Dim lp As Label = Sender
		If oldcol = "rgba(255,0,0,0.39)" Then
			CSSUtils.SetBorder(lp,2,fx.colors.ARGB(100,255,0,0),0)
		Else
			CSSUtils.SetBorder(lp,2,fx.colors.LightGray,0)
		End If
	Catch
		Log(LastException.Message)
	End Try
End Sub

Sub LG_MouseClicked (EventData As MouseEvent)
	Dim lp As Label = Sender
	TG.Text = lp.text
	TM.Text = NumberFormat2(lp.tag,2,0,0,False)
	Try
		wincal.Close
	Catch
		Log(LastException.Message)
	End Try
End Sub

Sub CHM_SelectedIndexChanged(Index As Int, Value As Object)
	Dim ch As ChoiceBox = Sender
	DateTime.DateFormat = "dd/MM/yyyy"
	TM.Text = NumberFormat2(ch.SelectedIndex+1,2,0,0,False)
	Dim dt As String = TG.Text&"/"&TM.Text&"/"&TA.text
	newdate = DateTime.DateParse(dt)
	DrawCalendar
End Sub

Sub CHA_SelectedIndexChanged(Index As Int, Value As Object)
	Dim ch As ChoiceBox = Sender
	DateTime.DateFormat = "dd/MM/yyyy"
	TA.Text = NumberFormat2(ch.Items.Get(ch.SelectedIndex),2,0,0,False)
	Dim dt As String = TG.Text&"/"&TM.Text&"/"&TA.text
	newdate = DateTime.DateParse(dt)
	DrawCalendar
End Sub

Sub LO1_MouseClicked (EventData As MouseEvent)
	Dim i As Int = HH.Text
	If i > 0 Then
		HH.Text = NumberFormat2(i-1,2,0,0,False)
		L5.Text = HH.Text
	Else
		HH.Text = 23
		L5.Text = 23
	End If
End Sub

Sub LO2_MouseClicked (EventData As MouseEvent)
	Dim i As Int = HH.Text
	If i < 23 Then
		HH.Text = NumberFormat2(i+1,2,0,0,False)
		L5.Text = HH.Text
	Else
		HH.Text = "00"
		L5.Text = "00"
	End If
End Sub

Sub LM1_MouseClicked (EventData As MouseEvent)
	Dim i As Int = MM.Text
	If i > 0 Then
		MM.Text = NumberFormat2(i-1,2,0,0,False)
		L6.Text = MM.Text
	Else
		MM.Text = "59"
		L6.Text = "59"
	End If
End Sub

Sub LM2_MouseClicked (EventData As MouseEvent)
	Dim i As Int = MM.Text
	If i < 59 Then
		MM.Text = NumberFormat2(i+1,2,0,0,False)
		L6.Text = MM.Text
	Else
		MM.Text = "00"
		L6.Text = "00"
	End If
End Sub
#End Region